//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using System;
			using System.IO;
			using System.Reflection;
			using System.Runtime.InteropServices;
			using System.Xml;
			
		#endregion
		
	// [DefaultMemberAttribute("Item")]
	public class CorrTableReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			private Point3D[] m_lstCorrectOffsets;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strType;
			private string m_strVersion;
			public const uint Opcode = 13;
			public readonly int Points;
			public readonly int TotalPoints;
		#endregion
		
		#region Constructors
		
			public CorrTableReader ()
			
			{
				int i1;
				this.m_strDefaultFileName = "CorrectionTable.xml";
				this.m_strType = "CorrTableData";
				this.m_strVersion = "1.0";
				this.Points = 65;
				this.TotalPoints = (this.Points * this.Points);
				this.m_lstCorrectOffsets = new Point3D[this.TotalPoints];
				for (i1 = 0; (i1 < this.TotalPoints); i1++)
				{
					this.m_lstCorrectOffsets[i1] = new Point3D (0D, 0D, 0D);
				}
			}
			
			
			static CorrTableReader ()
			
			{
				CorrTableReader.m_strDisplayName = "Correction Table";
			}
			
		#endregion
		
		#region Properties
		
			protected Point3D[] CorrectOffsets
			
			{
				get
				{
					return this.m_lstCorrectOffsets;
				}
				set
				{
					this.m_lstCorrectOffsets = value;
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return CorrTableReader.m_strDisplayName;
				}
			}
			
			
			public object this[int index]
			
			{
				get
				{
					if (index >= this.m_lstCorrectOffsets.Length)
					{
						return null;
					}
					else if (index >= 0)
					{
						return this.m_lstCorrectOffsets[index];
					}
					else
					{
						return null;
					}
				}
				set
				{
					if ((index >= 0) && (index < this.m_lstCorrectOffsets.Length))
					{
						this.m_lstCorrectOffsets[index] = (value as Point3D);
					}
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
		#endregion
		
		#region Methods
		
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				string string1;
				string[] stringArray1;
				int i2;
				string string2;
				double double1;
				string string3;
				char[] charArray1;
				string[] stringArray2;
				int i3;
				int i4;
				int i1 = 0;
				while (true)
				{
					while (pxmlRead.NodeType == XmlNodeType.Element)
					{
						if ((string3 = pxmlRead.Name) != null)
						{
							switch (string3)
							{
								case "Data":
								
								{
										string1 = pxmlRead.GetAttribute ("type");
										if (string1.CompareTo (this.Type) != 0)
										{
											throw new FormatException (("Parsing " + string1 + " when expecting " + this.Type));
										}
										bool b1 = pxmlRead.Read ();
										continue;
								}
								case "x-axis":
								
								{
										i1 = 1;
										bool b2 = pxmlRead.Read ();
										continue;
								}
								case "y-axis":
								
								{
										i1 = 2;
										bool b3 = pxmlRead.Read ();
										continue;
								}
								case "z-axis":
								
								{
										i1 = 3;
										bool b4 = pxmlRead.Read ();
										continue;
								}
							}
						}
						bool b5 = pxmlRead.Read ();
					}
					if ((pxmlRead.NodeType == XmlNodeType.Text) && (i1 > 0))
					{
						charArray1 = new char[] { '\u002C' };
						stringArray1 = pxmlRead.Value.Split (charArray1);
						i2 = 0;
						stringArray2 = stringArray1;
						for (i3 = 0; (i3 < stringArray2.Length); i3++)
						{
							string2 = stringArray2[i3];
							double1 = Convert.ToDouble (string2.Trim ());
							i4 = i1;
							switch (i4)
							{
								case 1:
								
								{
										this.m_lstCorrectOffsets[i2].X = double1;
										break;
								}
								case 2:
								
								{
										this.m_lstCorrectOffsets[i2].Y = double1;
										break;
								}
								case 3:
								
								{
										this.m_lstCorrectOffsets[i2].Z = double1;
										break;
								}
							}
							i2++;
						}
						i1 = 0;
					}
					if (! pxmlRead.Read ())
					{
						return;
					}
				}
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				if (pstrData.Length == 0)
				{
					return;
				}
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public void ProcessCorrectData (CorrTableReader poCorrect, int piTableId, ref byte[] pbyteBuf, out int piBufSize, ref int piIndexOpcode, out int piTotalOpcodes)
			
			{
				byte[] byteArray1;
				int i2;
				int i3;
				int i4;
				Exception exception1;
				int i5;
				Logging.Instance.Log (4, "DataThread.ProcessCorrectData() called.");
				piTotalOpcodes = (1 + (poCorrect.TotalPoints * 3));
				int i1 = 0;
				piBufSize = 0;
				try
				{
					byteArray1 = ((byte[]) null);
					if ((i1 >= piIndexOpcode) && ((piBufSize + 4) > pbyteBuf.Length))
					{
						piIndexOpcode = (i1 - 1);
						return;
					}
					i1++;
					i2 = 0;
					
				L_01B4:
					
					{
					}
					if (i2 < 3)
					{
						for (i3 = 0; (i3 < poCorrect.TotalPoints); i3++)
						{
							if (i1 >= piIndexOpcode)
							{
								if ((piBufSize + 8) > pbyteBuf.Length)
								{
									piIndexOpcode = (i1 - 1);
									return;
								}
								byteArray1 = BitConverter.GetBytes (20753);
								Array.Copy (((Array) byteArray1), 0, ((Array) pbyteBuf), piBufSize, byteArray1.Length);
								piBufSize += byteArray1.Length;
								byteArray1 = BitConverter.GetBytes (((short) (i3 + (poCorrect.TotalPoints * i2))));
								Array.Copy (((Array) byteArray1), 0, ((Array) pbyteBuf), piBufSize, byteArray1.Length);
								piBufSize += byteArray1.Length;
								i4 = 0;
								i5 = i2;
								switch (i5)
								{
									case 0:
									
									{
											i4 = Convert.ToInt32 (Math.Max (Math.Min (((Point3D) poCorrect[i3]).X, 2147483647D), -2147483648D));
											break;
									}
									case 1:
									
									{
											i4 = Convert.ToInt32 (Math.Max (Math.Min (((Point3D) poCorrect[i3]).Y, 2147483647D), -2147483648D));
											break;
									}
									case 2:
									
									{
											i4 = Convert.ToInt32 (Math.Max (Math.Min (((Point3D) poCorrect[i3]).Z, 2147483647D), -2147483648D));
											break;
									}
								}
								byteArray1 = BitConverter.GetBytes (i4);
								Array.Copy (((Array) byteArray1), 0, ((Array) pbyteBuf), piBufSize, byteArray1.Length);
								piBufSize += byteArray1.Length;
							}
							i1++;
						}
						i2++;
						goto L_01B4;
					}
					else
					{
						piIndexOpcode = i1;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.ProcessCorrectData() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
		#endregion
	}
	
}

