//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using System.Collections;
			using System.Collections.Generic;
			using System.Globalization;
			using System.IO;
			using System;
			using System.Text;
			using System.Xml;
			
		#endregion
		
	public class LaserConfigReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			private bool m_bExtPwrCtrl;
			private bool m_bFixedFreq;
			private bool m_bFixedPW;
			private bool m_bFixedWatts;
			private bool m_bInitLaser;
			private bool m_bLaserEnableHigh;
			private bool m_bLaserFPKHigh;
			private bool m_bLaserMOD1High;
			private bool m_bLaserMOD2High;
			private int m_bLaserOn2Cfg;
			private bool m_bLaserOn2High;
			private bool m_bLaserOnHigh;
			private bool m_bLaserPowerMode;
			private bool m_bUseExtPwrCtrl;
			private bool m_bVisiblePointer;
			private bool m_bWattsFlag;
			protected byte[] m_byteDelimiter;
			protected byte[] m_byteInterlockTxtFile;
			protected byte[] m_byteLaserName;
			protected byte[] m_byteLineEnd;
			private float m_fMaxFrequency;
			private float m_fMaxVolts;
			private float m_fMaxWatts;
			private float m_fMinFrequency;
			private float m_fMinVolts;
			private float m_fMinWatts;
			private float m_fTickleFrequency;
			private float m_fTickleFrequency2;
			private int m_iFpsPosition;
			private int m_iFpsWidth;
			private int m_iInitBits;
			private int m_iInitType;
			private int m_iLaserPowerDelay;
			private int m_iLaserPowerMap;
			private int m_iLaserType;
			private int m_iMaxBits;
			private int m_iMaxDutyCycle;
			private int m_iMaxPulseWidth;
			private int m_iMinBits;
			private int m_iMinDutyCycle;
			private int m_iMinPulseWidth;
			private int m_iTickleWidth;
			private int m_iTickleWidth2;
			private ArrayList m_lstCorrTable;
			private ArrayList m_lstDeinitStrings;
			private ArrayList m_lstInitStrings;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strType;
			private string m_strVersion;
			private uint m_uiBaudRate;
			private uint m_uiEnableDelay;
			private uint m_uiEnableTimeout;
			private uint m_uiLaserModDelay;
			private uint m_uiLaserTiming;
			public const uint Opcode = 6;
			private CultureInfo usCulture;
		#endregion
		
		#region Constructors
		
			public LaserConfigReader ()
			
			{
				this.usCulture = new CultureInfo ("en-US", false);
				this.m_strDefaultFileName = "LaserConfig.xml";
				this.m_strType = "LaserConfigData";
				this.m_strVersion = "1.0";
				this.m_bFixedFreq = true;
				this.m_bFixedPW = true;
				this.m_bFixedWatts = true;
				this.m_bLaserEnableHigh = true;
				this.m_bLaserOnHigh = true;
				this.m_bLaserOn2High = true;
				this.m_bLaserOn2Cfg = 2;
				this.m_bLaserMOD1High = true;
				this.m_bLaserMOD2High = true;
				this.m_bLaserFPKHigh = true;
				this.m_iMinPulseWidth = 2;
				this.m_iMaxPulseWidth = 65535;
				this.m_iMinBits = 1;
				this.m_iMaxBits = 100;
				this.m_iInitBits = 1;
				this.m_iFpsPosition = 30;
				this.m_iLaserPowerDelay = 500;
				this.m_iTickleWidth = 1;
				this.m_fTickleFrequency = 5F;
				this.m_iTickleWidth2 = 1;
				this.m_fTickleFrequency2 = 5F;
				this.m_iMaxDutyCycle = 100;
				this.m_iLaserType = 1;
				this.m_lstCorrTable = new ArrayList ();
				this.m_fMinFrequency = 0.02F;
				this.m_fMaxFrequency = 250F;
				this.m_fMaxWatts = 70F;
				this.m_fMaxVolts = 10F;
				this.m_byteLaserName = new UnicodeEncoding ().GetBytes ("Default Laser");
				this.m_byteLineEnd = new ASCIIEncoding ().GetBytes ("");
				this.m_byteDelimiter = new ASCIIEncoding ().GetBytes ("");
				this.m_byteInterlockTxtFile = new ASCIIEncoding ().GetBytes ("");
				this.m_lstInitStrings = new ArrayList ();
				this.m_lstDeinitStrings = new ArrayList ();
				this.m_uiLaserTiming = 49;
				this.Initialize ();
			}
			
			
			static LaserConfigReader ()
			
			{
				LaserConfigReader.m_strDisplayName = "Laser Configuration";
			}
			
		#endregion
		
		#region Properties
		
			public uint BaudRate
			
			{
				get
				{
					return this.m_uiBaudRate;
				}
				set
				{
					this.m_uiBaudRate = value;
				}
			}
			
			
			public ArrayList CorrTable
			
			{
				get
				{
					return this.m_lstCorrTable;
				}
				set
				{
					this.m_lstCorrTable = value;
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public ArrayList DeinitStrings
			
			{
				get
				{
					return this.m_lstDeinitStrings;
				}
				set
				{
					this.m_lstDeinitStrings = value;
				}
			}
			
			
			public string Delimiter
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteDelimiter, 0, ArrayEx.ValueLength (this.m_byteDelimiter, 0, this.m_byteDelimiter.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteDelimiter = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return LaserConfigReader.m_strDisplayName;
				}
			}
			
			
			public uint EnableDelay
			
			{
				get
				{
					return this.m_uiEnableDelay;
				}
				set
				{
					this.m_uiEnableDelay = value;
				}
			}
			
			
			public uint EnableTimeout
			
			{
				get
				{
					return this.m_uiEnableTimeout;
				}
				set
				{
					this.m_uiEnableTimeout = value;
				}
			}
			
			
			public bool ExtPwrCtrl
			
			{
				get
				{
					return this.m_bExtPwrCtrl;
				}
				set
				{
					this.m_bExtPwrCtrl = value;
				}
			}
			
			
			public bool FixedFreq
			
			{
				get
				{
					return this.m_bFixedFreq;
				}
				set
				{
					this.m_bFixedFreq = value;
				}
			}
			
			
			public bool FixedPW
			
			{
				get
				{
					return this.m_bFixedPW;
				}
				set
				{
					this.m_bFixedPW = value;
				}
			}
			
			
			public bool FixedWatts
			
			{
				get
				{
					return this.m_bFixedWatts;
				}
				set
				{
					this.m_bFixedWatts = value;
				}
			}
			
			
			public int FpsPosition
			
			{
				get
				{
					return this.m_iFpsPosition;
				}
				set
				{
					this.m_iFpsPosition = value;
				}
			}
			
			
			public int FpsWidth
			
			{
				get
				{
					return this.m_iFpsWidth;
				}
				set
				{
					this.m_iFpsWidth = value;
				}
			}
			
			
			public int InitBits
			
			{
				get
				{
					return this.m_iInitBits;
				}
				set
				{
					this.m_iInitBits = value;
				}
			}
			
			
			public bool InitLaser
			
			{
				get
				{
					return this.m_bInitLaser;
				}
				set
				{
					this.m_bInitLaser = value;
				}
			}
			
			
			public ArrayList InitStrings
			
			{
				get
				{
					return this.m_lstInitStrings;
				}
				set
				{
					this.m_lstInitStrings = value;
				}
			}
			
			
			public int InitType
			
			{
				get
				{
					return this.m_iInitType;
				}
				set
				{
					this.m_iInitType = value;
				}
			}
			
			
			public string InterlockTxtFile
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteInterlockTxtFile, 0, ArrayEx.ValueLength (this.m_byteInterlockTxtFile, 0, this.m_byteInterlockTxtFile.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteInterlockTxtFile = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public bool LaserEnableHigh
			
			{
				get
				{
					return this.m_bLaserEnableHigh;
				}
				set
				{
					this.m_bLaserEnableHigh = value;
				}
			}
			
			
			public bool LaserFPKHigh
			
			{
				get
				{
					return this.m_bLaserFPKHigh;
				}
				set
				{
					this.m_bLaserFPKHigh = value;
				}
			}
			
			
			public bool LaserMOD1High
			
			{
				get
				{
					return this.m_bLaserMOD1High;
				}
				set
				{
					this.m_bLaserMOD1High = value;
				}
			}
			
			
			public bool LaserMOD2High
			
			{
				get
				{
					return this.m_bLaserMOD2High;
				}
				set
				{
					this.m_bLaserMOD2High = value;
				}
			}
			
			
			public uint LaserModDelay
			
			{
				get
				{
					return this.m_uiLaserModDelay;
				}
				set
				{
					this.m_uiLaserModDelay = value;
				}
			}
			
			
			public string LaserName
			
			{
				get
				{
					byte[] byteArray1 = Encoding.Convert (Encoding.Unicode, Encoding.ASCII, this.m_byteLaserName);
					return Encoding.ASCII.GetString (byteArray1, 0, ArrayEx.ValueLength (byteArray1, 0, byteArray1.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteLaserName = new UnicodeEncoding ().GetBytes (value);
				}
			}
			
			
			public int LaserOn2Cfg
			
			{
				get
				{
					return this.m_bLaserOn2Cfg;
				}
				set
				{
					this.m_bLaserOn2Cfg = value;
				}
			}
			
			
			public bool LaserOn2High
			
			{
				get
				{
					return this.m_bLaserOn2High;
				}
				set
				{
					this.m_bLaserOn2High = value;
				}
			}
			
			
			public bool LaserOnHigh
			
			{
				get
				{
					return this.m_bLaserOnHigh;
				}
				set
				{
					this.m_bLaserOnHigh = value;
				}
			}
			
			
			public int LaserPowerDelay
			
			{
				get
				{
					return this.m_iLaserPowerDelay;
				}
				set
				{
					this.m_iLaserPowerDelay = value;
				}
			}
			
			
			public int LaserPowerMap
			
			{
				get
				{
					return this.m_iLaserPowerMap;
				}
				set
				{
					this.m_iLaserPowerMap = value;
				}
			}
			
			
			public bool LaserPowerMode
			
			{
				get
				{
					return this.m_bLaserPowerMode;
				}
				set
				{
					this.m_bLaserPowerMode = value;
				}
			}
			
			
			public uint LaserTiming
			
			{
				get
				{
					return this.m_uiLaserTiming;
				}
				set
				{
					this.m_uiLaserTiming = value;
				}
			}
			
			
			public int LaserType
			
			{
				get
				{
					return this.m_iLaserType;
				}
				set
				{
					this.m_iLaserType = value;
				}
			}
			
			
			public string LineEnd
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteLineEnd, 0, ArrayEx.ValueLength (this.m_byteLineEnd, 0, this.m_byteLineEnd.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteLineEnd = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public int MaxBits
			
			{
				get
				{
					return this.m_iMaxBits;
				}
				set
				{
					this.m_iMaxBits = value;
				}
			}
			
			
			public int MaxDutyCycle
			
			{
				get
				{
					return this.m_iMaxDutyCycle;
				}
				set
				{
					this.m_iMaxDutyCycle = value;
				}
			}
			
			
			public float MaxFrequency
			
			{
				get
				{
					return this.m_fMaxFrequency;
				}
				set
				{
					this.m_fMaxFrequency = value;
				}
			}
			
			
			public int MaxPulseWidth
			
			{
				get
				{
					return this.m_iMaxPulseWidth;
				}
				set
				{
					this.m_iMaxPulseWidth = value;
				}
			}
			
			
			public float MaxVolts
			
			{
				get
				{
					return this.m_fMaxVolts;
				}
				set
				{
					this.m_fMaxVolts = value;
				}
			}
			
			
			public float MaxWatts
			
			{
				get
				{
					return this.m_fMaxWatts;
				}
				set
				{
					this.m_fMaxWatts = value;
				}
			}
			
			
			public int MinBits
			
			{
				get
				{
					return this.m_iMinBits;
				}
				set
				{
					this.m_iMinBits = value;
				}
			}
			
			
			public int MinDutyCycle
			
			{
				get
				{
					return this.m_iMinDutyCycle;
				}
				set
				{
					this.m_iMinDutyCycle = value;
				}
			}
			
			
			public float MinFrequency
			
			{
				get
				{
					return this.m_fMinFrequency;
				}
				set
				{
					this.m_fMinFrequency = value;
				}
			}
			
			
			public int MinPulseWidth
			
			{
				get
				{
					return this.m_iMinPulseWidth;
				}
				set
				{
					this.m_iMinPulseWidth = value;
				}
			}
			
			
			public float MinVolts
			
			{
				get
				{
					return this.m_fMinVolts;
				}
				set
				{
					this.m_fMinVolts = value;
				}
			}
			
			
			public float MinWatts
			
			{
				get
				{
					return this.m_fMinWatts;
				}
				set
				{
					this.m_fMinWatts = value;
				}
			}
			
			
			public float TickleFrequency
			
			{
				get
				{
					return this.m_fTickleFrequency;
				}
				set
				{
					this.m_fTickleFrequency = value;
				}
			}
			
			
			public float TickleFrequency2
			
			{
				get
				{
					return this.m_fTickleFrequency2;
				}
				set
				{
					this.m_fTickleFrequency2 = value;
				}
			}
			
			
			public int TickleWidth
			
			{
				get
				{
					return this.m_iTickleWidth;
				}
				set
				{
					this.m_iTickleWidth = value;
				}
			}
			
			
			public int TickleWidth2
			
			{
				get
				{
					return this.m_iTickleWidth2;
				}
				set
				{
					this.m_iTickleWidth2 = value;
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public bool UseExtPwrCtrl
			
			{
				get
				{
					return this.m_bUseExtPwrCtrl;
				}
				set
				{
					this.m_bUseExtPwrCtrl = value;
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
			
			public bool VisiblePointer
			
			{
				get
				{
					return this.m_bVisiblePointer;
				}
				set
				{
					this.m_bVisiblePointer = value;
				}
			}
			
			
			public bool WattsFlag
			
			{
				get
				{
					return this.m_bWattsFlag;
				}
				set
				{
					this.m_bWattsFlag = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				if (pstrData.Length == 0)
				{
					return;
				}
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				string string1;
				string string2;
				int i1;
				Dictionary<String, Int32> dictionary21 = ((Dictionary<String, Int32>) null);
				if (this.CorrTable.Count != 0)
				{
					this.CorrTable.Clear ();
				}
				if (this.InitStrings.Count == 0)
				{
					this.InitStrings.Clear ();
				}
				if (this.DeinitStrings.Count == 0)
				{
					this.DeinitStrings.Clear ();
				}
				while (true)
				{
					while (pxmlRead.NodeType == XmlNodeType.Element)
					{
						if ((string2 = pxmlRead.Name) != null)
						{
							if (dictionary21 == null)
							{
								dictionary21 = new Dictionary<String, Int32> (58);
								dictionary21.Add ("Data", 0);
								dictionary21.Add ("FixedFreq", 1);
								dictionary21.Add ("FixedPW", 2);
								dictionary21.Add ("FixedWatts", 3);
								dictionary21.Add ("WattsUnits", 4);
								dictionary21.Add ("ExtPwrCtrl", 5);
								dictionary21.Add ("UseExtPwrCtrl", 6);
								dictionary21.Add ("VisPtr", 7);
								dictionary21.Add ("LENAHigh", 8);
								dictionary21.Add ("LONHigh", 9);
								dictionary21.Add ("LON2High", 10);
								dictionary21.Add ("LON2Cfg", 11);
								dictionary21.Add ("LsrPwrMode", 12);
								dictionary21.Add ("LMOD1High", 13);
								dictionary21.Add ("LMOD2High", 14);
								dictionary21.Add ("LFPKHigh", 15);
								dictionary21.Add ("InitLaser", 16);
								dictionary21.Add ("MinPulse", 17);
								dictionary21.Add ("MaxPulse", 18);
								dictionary21.Add ("Pulse", 19);
								dictionary21.Add ("MinBits", 20);
								dictionary21.Add ("MaxBits", 21);
								dictionary21.Add ("Bits", 22);
								dictionary21.Add ("InitBits", 23);
								dictionary21.Add ("FpsPos", 24);
								dictionary21.Add ("FpsWidth", 25);
								dictionary21.Add ("LsrPwrDly", 26);
								dictionary21.Add ("TickleWidth1", 27);
								dictionary21.Add ("TickleFreq1", 28);
								dictionary21.Add ("TickleWidth2", 29);
								dictionary21.Add ("TickleFreq2", 30);
								dictionary21.Add ("MinDuty", 31);
								dictionary21.Add ("MaxDuty", 32);
								dictionary21.Add ("Duty", 33);
								dictionary21.Add ("LsrType", 34);
								dictionary21.Add ("LsrPowerMap", 35);
								dictionary21.Add ("InitType", 36);
								dictionary21.Add ("BaudRate", 37);
								dictionary21.Add ("MinFreq", 38);
								dictionary21.Add ("MaxFreq", 39);
								dictionary21.Add ("Freq", 40);
								dictionary21.Add ("MinWatts", 41);
								dictionary21.Add ("MaxWatts", 42);
								dictionary21.Add ("Watts", 43);
								dictionary21.Add ("MinVolts", 44);
								dictionary21.Add ("MaxVolts", 45);
								dictionary21.Add ("Volts", 46);
								dictionary21.Add ("LsrEnaDly", 47);
								dictionary21.Add ("LsrEnaTmo", 48);
								dictionary21.Add ("Entry", 49);
								dictionary21.Add ("LsrName", 50);
								dictionary21.Add ("InitStrEOL", 51);
								dictionary21.Add ("InitStrDelim", 52);
								dictionary21.Add ("Interlock", 53);
								dictionary21.Add ("InitString", 54);
								dictionary21.Add ("DeinitString", 55);
								dictionary21.Add ("LsrTiming", 56);
								dictionary21.Add ("LsrModDly", 57);
							}
							if (dictionary21.TryGetValue (string2, out i1))
							{
								switch (i1)
								{
									case 0:
									
									{
											string1 = pxmlRead.GetAttribute ("type");
											if (string1.CompareTo (this.Type) != 0)
											{
												throw new FormatException (("Parsing " + string1 + " when expecting " + this.Type));
											}
											bool b1 = pxmlRead.Read ();
											continue;
									}
									case 1:
									
									{
											bool b2 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.FixedFreq = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 2:
									
									{
											bool b3 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.FixedPW = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 3:
									
									{
											bool b4 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.FixedWatts = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 4:
									
									{
											bool b5 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.WattsFlag = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 5:
									
									{
											bool b6 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.ExtPwrCtrl = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 6:
									
									{
											bool b7 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.UseExtPwrCtrl = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 7:
									
									{
											bool b8 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.VisiblePointer = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 8:
									
									{
											bool b9 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserEnableHigh = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 9:
									
									{
											bool b10 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserOnHigh = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 10:
									
									{
											bool b11 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserOn2High = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 11:
									
									{
											bool b12 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserOn2Cfg = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 12:
									
									{
											bool b13 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											if (pxmlRead.Value.ToLower ().CompareTo ("7bit") != 0)
											{
												this.LaserPowerMode = false;
												continue;
											}
											this.LaserPowerMode = true;
											continue;
									}
									case 13:
									
									{
											bool b14 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserMOD1High = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 14:
									
									{
											bool b15 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserMOD2High = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 15:
									
									{
											bool b16 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserFPKHigh = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 16:
									
									{
											bool b17 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.InitLaser = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 17:
									
									{
											bool b18 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MinPulseWidth = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 18:
									
									{
											bool b19 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MaxPulseWidth = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 19:
									
									{
											this.MinPulseWidth = Convert.ToInt32 (pxmlRead.GetAttribute ("min"));
											this.MaxPulseWidth = Convert.ToInt32 (pxmlRead.GetAttribute ("max"));
											bool b20 = pxmlRead.Read ();
											continue;
									}
									case 20:
									
									{
											bool b21 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MinBits = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 21:
									
									{
											bool b22 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MaxBits = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 22:
									
									{
											this.MinBits = Convert.ToInt32 (pxmlRead.GetAttribute ("min"));
											this.MaxBits = Convert.ToInt32 (pxmlRead.GetAttribute ("max"));
											bool b23 = pxmlRead.Read ();
											continue;
									}
									case 23:
									
									{
											bool b24 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.InitBits = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 24:
									
									{
											bool b25 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.FpsPosition = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 25:
									
									{
											bool b26 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.FpsWidth = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 26:
									
									{
											bool b27 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserPowerDelay = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 27:
									
									{
											bool b28 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.TickleWidth = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 28:
									
									{
											bool b29 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.TickleFrequency = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 29:
									
									{
											bool b30 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.TickleWidth2 = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 30:
									
									{
											bool b31 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.TickleFrequency2 = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 31:
									
									{
											bool b32 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MinDutyCycle = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 32:
									
									{
											bool b33 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MaxDutyCycle = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 33:
									
									{
											this.MinDutyCycle = Convert.ToInt32 (pxmlRead.GetAttribute ("min"));
											this.MaxDutyCycle = Convert.ToInt32 (pxmlRead.GetAttribute ("max"));
											bool b34 = pxmlRead.Read ();
											continue;
									}
									case 34:
									
									{
											bool b35 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserType = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 35:
									
									{
											bool b36 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserPowerMap = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 36:
									
									{
											bool b37 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.InitType = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 37:
									
									{
											bool b38 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.BaudRate = Convert.ToUInt32 (pxmlRead.Value);
											continue;
									}
									case 38:
									
									{
											bool b39 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MinFrequency = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 39:
									
									{
											bool b40 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MaxFrequency = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 40:
									
									{
											this.MinFrequency = ((float) Convert.ToDouble (pxmlRead.GetAttribute ("min"), ((IFormatProvider) this.usCulture)));
											this.MaxFrequency = ((float) Convert.ToDouble (pxmlRead.GetAttribute ("max"), ((IFormatProvider) this.usCulture)));
											bool b41 = pxmlRead.Read ();
											continue;
									}
									case 41:
									
									{
											bool b42 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MinWatts = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 42:
									
									{
											bool b43 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MaxWatts = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 43:
									
									{
											this.MinWatts = ((float) Convert.ToDouble (pxmlRead.GetAttribute ("min"), ((IFormatProvider) this.usCulture)));
											this.MaxWatts = ((float) Convert.ToDouble (pxmlRead.GetAttribute ("max"), ((IFormatProvider) this.usCulture)));
											bool b44 = pxmlRead.Read ();
											continue;
									}
									case 44:
									
									{
											bool b45 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MinVolts = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 45:
									
									{
											bool b46 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MaxVolts = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 46:
									
									{
											this.MinVolts = ((float) Convert.ToDouble (pxmlRead.GetAttribute ("min"), ((IFormatProvider) this.usCulture)));
											this.MaxVolts = ((float) Convert.ToDouble (pxmlRead.GetAttribute ("max"), ((IFormatProvider) this.usCulture)));
											bool b47 = pxmlRead.Read ();
											continue;
									}
									case 47:
									
									{
											bool b48 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.EnableDelay = Convert.ToUInt32 (pxmlRead.Value);
											continue;
									}
									case 48:
									
									{
											bool b49 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.EnableTimeout = Convert.ToUInt32 (pxmlRead.Value);
											continue;
									}
									case 49:
									
									{
											bool b50 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											int i2 = this.CorrTable.Add (Convert.ToInt32 (pxmlRead.Value));
											continue;
									}
									case 50:
									
									{
											bool b51 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserName = pxmlRead.Value;
											continue;
									}
									case 51:
									
									{
											bool b52 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LineEnd = pxmlRead.Value;
											continue;
									}
									case 52:
									
									{
											bool b53 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Delimiter = pxmlRead.Value;
											continue;
									}
									case 53:
									
									{
											bool b54 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.InterlockTxtFile = pxmlRead.Value;
											continue;
									}
									case 54:
									
									{
											bool b55 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											int i3 = this.InitStrings.Add (new ASCIIEncoding ().GetBytes (pxmlRead.Value));
											continue;
									}
									case 55:
									
									{
											bool b56 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											int i4 = this.DeinitStrings.Add (new ASCIIEncoding ().GetBytes (pxmlRead.Value));
											continue;
									}
									case 56:
									
									{
											bool b57 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserTiming = Convert.ToUInt32 (pxmlRead.Value);
											continue;
									}
									case 57:
									
									{
											bool b58 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserModDelay = Convert.ToUInt32 (pxmlRead.Value);
											continue;
									}
								}
							}
						}
						bool b59 = pxmlRead.Read ();
					}
					if (! pxmlRead.Read ())
					{
						return;
					}
				}
			}
			
			private void Initialize ()
			
			{
				int i1;
				int i2;
				int i3;
				if (this.CorrTable.Count == 0)
				{
					for (i1 = 0; (i1 < 256); i1++)
					{
						int i4 = this.CorrTable.Add (i1);
					}
				}
				byte[] byteArray1 = new byte[1];
				if (this.InitStrings.Count == 0)
				{
					for (i2 = 0; (i2 < 20); i2++)
					{
						int i5 = this.InitStrings.Add (byteArray1);
					}
				}
				if (this.DeinitStrings.Count == 0)
				{
					for (i3 = 0; (i3 < 10); i3++)
					{
						int i6 = this.DeinitStrings.Add (byteArray1);
					}
				}
			}
			
		#endregion
	}
	
}

