//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using System.Net;
			using System;
			using System.Text;
			
		#endregion
		
	public class TransmitPacket
	
	{
		
		#region Fields
			public byte[] Data;
			public static int FixedPacketSize;
			public const int IPLength = 8;
			private IPAddress m_ipAddress;
			private IPAddress m_ipRequestAddress;
			private uint m_uiDataSize;
			private uint m_uiOpcode;
			private uint m_uiProtocolVersion;
			public readonly byte[] Protocol;
			public const string TransmitIdentify = "LECt";
		#endregion
		
		#region Constructors
		
			public TransmitPacket ()
			
			{
				this.Protocol = new ASCIIEncoding ().GetBytes ("LECt");
				this.Initialize ();
			}
			
			
			public TransmitPacket (byte[] pbPacketStream)
			
			{
				this.Protocol = new ASCIIEncoding ().GetBytes ("LECt");
				this.Initialize ();
				int i1 = 0;
				if ((i1 >= pbPacketStream.Length) || (! ArrayEx.CompareTo (pbPacketStream, this.Protocol, this.Protocol.Length)))
				{
					return;
				}
				i1 += this.Protocol.Length;
				if (i1 >= pbPacketStream.Length)
				{
					return;
				}
				this.m_uiProtocolVersion = BitConverter.ToUInt32 (pbPacketStream, i1);
				i1 += 4;
				if (i1 >= pbPacketStream.Length)
				{
					return;
				}
				object[] objectArray1 = new object[] { Convert.ToInt32 (pbPacketStream[i1]), Convert.ToInt32 (pbPacketStream[(i1 + 1)]), Convert.ToInt32 (pbPacketStream[(i1 + 2)]), Convert.ToInt32 (pbPacketStream[(i1 + 3)]) };
				string string1 = string.Format ("{0}.{1}.{2}.{3}", objectArray1);
				this.m_ipAddress = IPAddress.Parse (string1);
				i1 += 8;
				if (i1 >= pbPacketStream.Length)
				{
					return;
				}
				object[] objectArray2 = new object[] { Convert.ToInt32 (pbPacketStream[i1]), Convert.ToInt32 (pbPacketStream[(i1 + 1)]), Convert.ToInt32 (pbPacketStream[(i1 + 2)]), Convert.ToInt32 (pbPacketStream[(i1 + 3)]) };
				string1 = string.Format ("{0}.{1}.{2}.{3}", objectArray2);
				this.m_ipRequestAddress = IPAddress.Parse (string1);
				i1 += 8;
				if (i1 < pbPacketStream.Length)
				{
					this.m_uiOpcode = ((uint) BitConverter.ToInt32 (pbPacketStream, i1));
					i1 += 4;
					if (i1 < pbPacketStream.Length)
					{
						this.m_uiDataSize = ((uint) BitConverter.ToInt32 (pbPacketStream, i1));
						i1 += 4;
						if ((i1 < pbPacketStream.Length) && (this.m_uiDataSize > uint.MinValue))
						{
							this.Data = new byte[this.m_uiDataSize];
							Array.Copy (((Array) pbPacketStream), i1, ((Array) this.Data), 0, ((int) this.m_uiDataSize));
							i1 += ((int) this.m_uiDataSize);
						}
					}
				}
			}
			
			
			static TransmitPacket ()
			
			{
				TransmitPacket.FixedPacketSize = ((((("LECt".Length + 4) + 8) + 8) + 4) + 4);
			}
			
		#endregion
		
		#region Properties
		
			public IPAddress Address
			
			{
				get
				{
					return this.m_ipAddress;
				}
				set
				{
					this.m_ipAddress = value;
				}
			}
			
			
			public uint DataSize
			
			{
				get
				{
					return this.m_uiDataSize;
				}
				set
				{
					this.m_uiDataSize = value;
				}
			}
			
			
			public uint Opcode
			
			{
				get
				{
					return this.m_uiOpcode;
				}
				set
				{
					this.m_uiOpcode = value;
				}
			}
			
			
			public uint ProtocolVersion
			
			{
				get
				{
					return this.m_uiProtocolVersion;
				}
				set
				{
					this.m_uiProtocolVersion = value;
				}
			}
			
			
			public IPAddress RequestAddress
			
			{
				get
				{
					return this.m_ipRequestAddress;
				}
				set
				{
					this.m_ipRequestAddress = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			private void Initialize ()
			
			{
				this.m_uiProtocolVersion = 1;
				this.m_uiOpcode = uint.MinValue;
				this.m_uiDataSize = uint.MinValue;
				this.m_ipAddress = ((IPAddress) null);
				this.m_ipRequestAddress = ((IPAddress) null);
			}
			
			public byte[] ToBytes ()
			
			{
				byte[] byteArray1 = BitConverter.GetBytes (this.m_uiProtocolVersion);
				byte[] byteArray2 = new byte[8];
				if (this.m_ipAddress != null)
				{
					byteArray2 = this.m_ipAddress.GetAddressBytes ();
				}
				byte[] byteArray3 = new byte[8];
				if (this.m_ipRequestAddress != null)
				{
					byteArray3 = this.m_ipRequestAddress.GetAddressBytes ();
				}
				byte[] byteArray4 = BitConverter.GetBytes (this.m_uiOpcode);
				byte[] byteArray5 = BitConverter.GetBytes (this.m_uiDataSize);
				byte[] byteArray6 = new byte[((((((((this.Protocol.Length + byteArray1.Length) + byteArray2.Length) + ((byteArray2.Length < 8) ? (8 - byteArray2.Length) : 0)) + byteArray3.Length) + ((byteArray3.Length < 8) ? (8 - byteArray3.Length) : 0)) + byteArray4.Length) + byteArray5.Length) + ((this.Data != null) ? this.Data.Length : 0))];
				int i1 = 0;
				Array.Copy (((Array) this.Protocol), 0, ((Array) byteArray6), i1, this.Protocol.Length);
				i1 += this.Protocol.Length;
				Array.Copy (((Array) byteArray1), 0, ((Array) byteArray6), i1, byteArray1.Length);
				i1 += byteArray1.Length;
				Array.Copy (((Array) byteArray2), 0, ((Array) byteArray6), i1, byteArray2.Length);
				i1 += byteArray2.Length;
				if (byteArray2.Length < 8)
				{
					i1 += (8 - byteArray2.Length);
				}
				Array.Copy (((Array) byteArray3), 0, ((Array) byteArray6), i1, byteArray3.Length);
				i1 += byteArray3.Length;
				if (byteArray3.Length < 8)
				{
					i1 += (8 - byteArray3.Length);
				}
				Array.Copy (((Array) byteArray4), 0, ((Array) byteArray6), i1, byteArray4.Length);
				i1 += byteArray4.Length;
				Array.Copy (((Array) byteArray5), 0, ((Array) byteArray6), i1, byteArray5.Length);
				i1 += byteArray5.Length;
				if (this.m_uiDataSize > uint.MinValue)
				{
					Array.Copy (((Array) this.Data), 0, ((Array) byteArray6), i1, this.Data.Length);
					i1 += this.Data.Length;
				}
				return byteArray6;
			}
			
		#endregion
	}
	
}

