//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:22:12
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.FTP

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.IO;
			
		#endregion
		
	public class FileItem : IComparable
	
	{
		
		#region Fields
			private DateTime m_FileDate;
			private string m_FileGroup;
			private string m_FileOwner;
			private string m_FilePath;
			private string m_FilePermissions;
			private long m_FileSize;
			private string m_FileTitle;
			private bool m_IsDirectory;
		#endregion
		
		#region Constructors
		
			public FileItem ()
			
			{
				this.m_FileTitle = "";
				this.m_FileOwner = "";
				this.m_FileGroup = "";
				this.m_FilePermissions = "";
				this.m_FilePath = "";
			}
			
			
			public FileItem (string ObjectName, bool IsDirectory)
			
			{
				DirectoryInfo directoryInfo1;
				FileInfo fileInfo1;
				this.m_FileTitle = "";
				this.m_FileOwner = "";
				this.m_FileGroup = "";
				this.m_FilePermissions = "";
				this.m_FilePath = "";
				if (ObjectName == null)
				{
					throw new ArgumentNullException ();
				}
				else
				{
					this.m_IsDirectory = IsDirectory;
					if (this.m_IsDirectory)
					{
						try
						{
							directoryInfo1 = new DirectoryInfo (ObjectName);
							this.m_FileTitle = directoryInfo1.Name;
							this.m_FileSize = 0L;
							this.m_FilePath = directoryInfo1.FullName;
							this.m_FilePath = this.m_FilePath.Substring (0, ((int) (this.m_FilePath.Length - this.m_FileTitle.Length)));
							this.m_FileDate = directoryInfo1.LastWriteTime;
							return;
						}
						catch
						{
							throw new ArgumentException ();
						}
					}
					else
					{
						try
						{
							fileInfo1 = new FileInfo (ObjectName);
							this.m_FileTitle = fileInfo1.Name;
							this.m_FileSize = fileInfo1.Length;
							this.m_FilePath = fileInfo1.DirectoryName;
							this.m_FileDate = fileInfo1.LastWriteTime;
						}
						catch
						{
							throw new ArgumentException ();
						}
					}
				}
			}
			
		#endregion
		
		#region Properties
		
			public DateTime FileDate
			
			{
				get
				{
					return this.m_FileDate;
				}
				set
				{
					this.m_FileDate = value;
				}
			}
			
			
			public string FileGroup
			
			{
				get
				{
					return this.m_FileGroup;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.m_FileGroup = value;
					}
				}
			}
			
			
			public string FileOwner
			
			{
				get
				{
					return this.m_FileOwner;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.m_FileOwner = value;
					}
				}
			}
			
			
			public string FilePath
			
			{
				get
				{
					return this.m_FilePath;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.m_FilePath = value;
					}
				}
			}
			
			
			public string FilePermissions
			
			{
				get
				{
					return this.m_FilePermissions;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.m_FilePermissions = value;
					}
				}
			}
			
			
			public long FileSize
			
			{
				get
				{
					return this.m_FileSize;
				}
				set
				{
					this.m_FileSize = value;
				}
			}
			
			
			public string FileTitle
			
			{
				get
				{
					return this.m_FileTitle;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.m_FileTitle = value;
					}
				}
			}
			
			
			public bool IsDirectory
			
			{
				get
				{
					return this.m_IsDirectory;
				}
				set
				{
					this.m_IsDirectory = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual int CompareTo (object obj)
			
			{
				if (obj == null)
				{
					return -1;
				}
				FileItem fileItem1 = ((FileItem) obj);
				if (this.m_IsDirectory && (! fileItem1.IsDirectory))
				{
					return -1;
				}
				else if ((! this.m_IsDirectory) && fileItem1.IsDirectory)
				{
					return 1;
				}
				else if (string.Compare (this.m_FileTitle.ToLower (), fileItem1.FileTitle.ToLower ()) > 0)
				{
					return 1;
				}
				else if (string.Compare (this.m_FileTitle.ToLower (), fileItem1.FileTitle.ToLower ()) >= 0)
				{
					return 0;
				}
				else
				{
					return -1;
				}
			}
			
		#endregion
	}
	
}

