//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:23:08
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECBroadcast

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using System;
			using System.Collections;
			using System.IO;
			using System.Net;
			using System.Net.Sockets;
			using System.Runtime.InteropServices;
			using System.Text;
			using System.Threading;
			using System.Xml;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	[ComVisibleAttribute(false)]
	public sealed class LECReceiveThread : BaseThread
	
	{
		
		#region Fields
			public static readonly uint AdvertiseAddStatInfo;
			public static readonly uint AdvertiseAddSysInfo;
			public static readonly uint AdvertiseDeleteStatInfo;
			public static readonly uint AdvertiseDeleteSysInfo;
			public static readonly uint AdvertiseUpdateStatInfo;
			public static readonly uint AdvertiseUpdateSysInfo;
			public static readonly int ExpirationTime;
			private IPAddress localIPAddress;
			private byte[] m_bReceived;
			private int m_iPort;
			private UdpClient m_oClientReceive;
			private IPEndPoint m_oGroupEP;
			private ManualResetEvent m_oReceiveEvent;
			private IPAddress multicastIPAddress;
			public event AdvertiseEventHandler OnAdvertiseEvent;
		#endregion
		
		#region Constructors
		
			public LECReceiveThread (IPAddress multicastAddress, IPAddress localAddress, int localPort)
			
			{
				this.m_oReceiveEvent = new ManualResetEvent (false);
				this.MulticastAddress = multicastAddress;
				this.LocalAddress = localAddress;
				this.LocalPort = localPort;
			}
			
			
			static LECReceiveThread ()
			
			{
				LECReceiveThread.AdvertiseAddSysInfo = uint.MinValue;
				LECReceiveThread.AdvertiseAddStatInfo = 1;
				LECReceiveThread.AdvertiseUpdateSysInfo = 2;
				LECReceiveThread.AdvertiseDeleteSysInfo = 3;
				LECReceiveThread.AdvertiseUpdateStatInfo = 4;
				LECReceiveThread.AdvertiseDeleteStatInfo = 5;
				LECReceiveThread.ExpirationTime = 8000;
			}
			
		#endregion
		
		#region Properties
		
			public IPAddress LocalAddress
			
			{
				get
				{
					return this.localIPAddress;
				}
				set
				{
					this.localIPAddress = value;
				}
			}
			
			
			public int LocalPort
			
			{
				get
				{
					return this.m_iPort;
				}
				set
				{
					this.m_iPort = value;
				}
			}
			
			
			public IPAddress MulticastAddress
			
			{
				get
				{
					return this.multicastIPAddress;
				}
				set
				{
					this.multicastIPAddress = value;
				}
			}
			
			
			public ArrayList ServerArrayList
			
			{
				get
				{
					return this.GetServerNameList ();
				}
			}
			
			
			public string ServerList
			
			{
				get
				{
					StringWriter stringWriter1 = new StringWriter ();
					XmlTextWriter xmlTextWriter1 = new XmlTextWriter (((TextWriter) stringWriter1));
					xmlTextWriter1.WriteStartElement (((string) null), "LECList", ((string) null));
					foreach (BroadcastNameData broadcastNameData1 in this.GetServerNameList ())
					{
						xmlTextWriter1.WriteStartElement (((string) null), "LEC", ((string) null));
						xmlTextWriter1.WriteAttributeString (((string) null), "name", ((string) null), broadcastNameData1.Name);
						xmlTextWriter1.WriteAttributeString (((string) null), "ip", ((string) null), broadcastNameData1.IP);
						xmlTextWriter1.WriteAttributeString (((string) null), "mac", ((string) null), broadcastNameData1.MAC);
						xmlTextWriter1.WriteEndElement ();
					}
					xmlTextWriter1.WriteEndElement ();
					return stringWriter1.ToString ();
				}
			}
			
			
			public int ServerListCount
			
			{
				get
				{
					ArrayList arrayList1 = this.GetServerNameList ();
					return arrayList1.Count;
				}
			}
			
		#endregion
		
		#region Methods
		
			public bool AddData (BaseConfig poData)
			
			{
				this.UpdateServerList (((IPAddress) null), poData);
				return true;
			}
			
			protected override bool ExecuteWorkThread ()
			
			{
				Thread thread1;
				byte[] byteArray1;
				ServerAdPacket serverAdPacket1;
				BaseConfig baseConfig1;
				Exception exception1;
				uint uInt32_1;
				try
				{
					this.m_oGroupEP = new IPEndPoint (this.MulticastAddress, this.LocalPort);
					while (! base.Shutdown)
					{
						bool b2 = this.m_oReceiveEvent.Reset ();
						thread1 = new Thread (new ThreadStart (this.ReceiveProc));
						thread1.IsBackground = true;
						thread1.Start ();
						bool b3 = this.m_oReceiveEvent.WaitOne ();
						if (base.Shutdown)
						{
							return false;
						}
						if (this.m_bReceived == null)
						{
							continue;
						}
						byteArray1 = new byte[4];
						Array.Copy (((Array) this.m_bReceived), ((Array) byteArray1), byteArray1.Length);
						if ("LECs".CompareTo (Encoding.ASCII.GetString (byteArray1)) != 0)
						{
							continue;
						}
						serverAdPacket1 = new ServerAdPacket (this.m_bReceived);
						baseConfig1 = ((BaseConfig) null);
						uInt32_1 = serverAdPacket1.Opcode;
						if (uInt32_1 == 1)
						{
							baseConfig1 = ((BaseConfig) new SysInfoData (serverAdPacket1.Data));
						}
						else if (uInt32_1 == 7)
						{
							baseConfig1 = ((BaseConfig) new StatInfoData (serverAdPacket1.Data));
						}
						if (baseConfig1 != null)
						{
							this.UpdateServerList (serverAdPacket1.Address, baseConfig1);
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (("LECReceive.ExecuteWorkThread() - Exception 0x03d  " + exception1.Message));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return false;
			}
			
			public bool GetData (string pstrServerName, int piData, out BaseConfig poData)
			
			{
				return (this.GetLocData (pstrServerName, piData, out poData) != -1);
			}
			
			public bool GetData (string pstrServerName, int piData, out string pstrData)
			
			{
				BaseConfig baseConfig1 = ((BaseConfig) null);
				if (! this.GetData (pstrServerName, piData, out baseConfig1))
				{
					pstrData = "";
					return false;
				}
				else
				{
					pstrData = ((IBaseXmlWriter) baseConfig1).ToXML ();
					return true;
				}
			}
			
			private int GetDetectedDeviceData (string pstrServerName, int piData, out DeviceBroadcastPacket poData)
			
			{
				SysInfoData sysInfoData1;
				StatInfoData statInfoData1;
				string string1;
				bool b2;
				int i3;
				DeviceBroadcastPacket deviceBroadcastPacket1;
				bool b3;
				Type type1 = ((Type) null);
				int i4 = piData;
				if (i4 == 1)
				{
					sysInfoData1 = new SysInfoData ();
					type1 = sysInfoData1.GetType ();
				}
				else if (i4 == 7)
				{
					statInfoData1 = new StatInfoData ();
					type1 = statInfoData1.GetType ();
				}
				int i1 = pstrServerName.IndexOf ("@");
				if (i1 != -1)
				{
					string1 = pstrServerName.Substring (((int) (i1 + 1)));
				}
				else
				{
					string1 = pstrServerName;
				}
				int i2 = 0;
				bool b1 = false;
				while (true)
				{
					b2 = false;
					for (i3 = 0; (i3 < BroadcastPacketList.Instance.Count); i3++)
					{
						deviceBroadcastPacket1 = BroadcastPacketList.Instance[i3];
						b3 = (pstrServerName.CompareTo (deviceBroadcastPacket1.ServerData.ServerName) == 0);
						if (type1 == deviceBroadcastPacket1.GetDataType ())
						{
							if (((deviceBroadcastPacket1.ServerAddress != null) && (deviceBroadcastPacket1.ServerAddress.ToString ().CompareTo (string1) == 0)) || b3)
							{
								poData = deviceBroadcastPacket1;
								return i2;
							}
							b1 = true;
						}
						if (((i1 == -1) && b3) && (deviceBroadcastPacket1.ServerAddress != null))
						{
							string1 = deviceBroadcastPacket1.ServerAddress.ToString ();
							i1 = 0;
							if (b1)
							{
								b2 = true;
							}
						}
						i2++;
					}
					if (! b2)
					{
						poData = ((DeviceBroadcastPacket) null);
						return -1;
					}
				}
			}
			
			public int GetLocData (string pstrServerName, int piData, out BaseConfig poData)
			
			{
				DeviceBroadcastPacket deviceBroadcastPacket1 = ((DeviceBroadcastPacket) null);
				int i1 = this.GetDetectedDeviceData (pstrServerName, piData, out deviceBroadcastPacket1);
				if (i1 == -1)
				{
					poData = ((BaseConfig) null);
					return i1;
				}
				poData = deviceBroadcastPacket1.ServerData;
				if (deviceBroadcastPacket1.ClientData.Length <= 0)
				{
					return i1;
				}
				if (piData != 1)
				{
					return i1;
				}
				SysInfoData sysInfoData1 = (poData as SysInfoData);
				IPAddress iPAddress1 = IPAddress.Parse ("0.0.0.0");
				uint uInt32_1 = Convert.ToUInt32 (deviceBroadcastPacket1.ClientData);
				if ((uInt32_1 == 1) || (uInt32_1 == 64))
				{
					iPAddress1 = IPAddressEx.CurrentAddress;
				}
				sysInfoData1.ConnectedAddress = iPAddress1;
				sysInfoData1.StateCode = uInt32_1;
				return i1;
			}
			
			private ArrayList GetServerNameList ()
			
			{
				int i1;
				DeviceBroadcastPacket deviceBroadcastPacket1;
				string string2;
				string string3;
				string string4;
				ArrayList arrayList1 = new ArrayList ();
				string string1 = "";
				for (i1 = 0; (i1 < BroadcastPacketList.Instance.Count); i1++)
				{
					deviceBroadcastPacket1 = BroadcastPacketList.Instance[i1];
					if (! (deviceBroadcastPacket1.ServerData is StatInfoData))
					{
						string2 = ((deviceBroadcastPacket1.ServerAddress == null) ? "" : deviceBroadcastPacket1.ServerAddress.ToString ());
						string3 = ((deviceBroadcastPacket1.ServerData.ServerName.Length > 0) ? deviceBroadcastPacket1.ServerData.ServerName : string2);
						string4 = ((deviceBroadcastPacket1.ServerData is SysInfoData) ? ((SysInfoData) deviceBroadcastPacket1.ServerData).NodeMACAddress : "");
						if (((string2.Length > 0) || ((string3.Length > 0) || (string4.Length > 0))) && (((string1.Length == 0) || ((string2.Length > 0) && (string1.IndexOf (string2) == -1))) || ((string3.Length > 0) && (string1.IndexOf (string3) == -1))))
						{
							if (string2.Length > 0)
							{
								string1 = (string1 + " " + string2);
							}
							else
							{
								string1 = (string1 + " " + string3);
							}
							int i2 = arrayList1.Add (new BroadcastNameData (string3, string2, string4));
						}
					}
				}
				return arrayList1;
			}
			
			protected override bool InitializeWorkThread ()
			
			{
				IPEndPoint iPEndPoint1;
				bool b1;
				try
				{
					if ((this.LocalAddress.ToString () == "0.0.0.0") || (this.LocalAddress.ToString () == ""))
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Any, this.LocalPort);
					}
					else
					{
						iPEndPoint1 = new IPEndPoint (this.LocalAddress, this.LocalPort);
					}
					this.m_oClientReceive = new UdpClient (iPEndPoint1);
					if (this.m_oClientReceive == null)
					{
						return false;
					}
					else
					{
						this.m_oClientReceive.JoinMulticastGroup (this.MulticastAddress, 50);
						b1 = true;
					}
				}
				catch (Exception)
				{
					b1 = false;
				}
				return b1;
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				if (pbAbort)
				{
					base.Shutdown = true;
					bool b1 = this.m_oReceiveEvent.Set ();
				}
				base.InterruptWorkThread (pbAbort);
			}
			
			private void ReceiveProc ()
			
			{
				try
				{
					try
					{
						if ((this.m_oClientReceive != null) && (this.m_oGroupEP != null))
						{
							this.m_bReceived = this.m_oClientReceive.Receive (ref this.m_oGroupEP);
						}
					}
					catch (Exception)
					{
					}
				}
				finally
				{
					bool b1 = this.m_oReceiveEvent.Set ();
				}
			}
			
			public bool SetClientData (int piIndex, string poClientData)
			
			{
				if (piIndex < 0)
				{
					return false;
				}
				else if (piIndex >= BroadcastPacketList.Instance.Count)
				{
					return false;
				}
				else
				{
					BroadcastPacketList.Instance[piIndex].ClientData = poClientData;
					return true;
				}
			}
			
			public bool SetData (int piIndex, BaseConfig poData)
			
			{
				if (piIndex < 0)
				{
					return false;
				}
				else if (piIndex >= BroadcastPacketList.Instance.Count)
				{
					return false;
				}
				else
				{
					BroadcastPacketList.Instance[piIndex].ServerData = poData;
					return true;
				}
			}
			
			protected override bool TerminateWorkThread ()
			
			{
				this.m_oClientReceive.Close ();
				return base.TerminateWorkThread ();
			}
			
			private void UpdateServerList (IPAddress pipAddress, BaseConfig newDataPackage)
			
			{
				int i1;
				DeviceBroadcastPacket deviceBroadcastPacket1;
				bool b1;
				byte[] byteArray1;
				byte[] byteArray2;
				byte[] byteArray3;
				byte[] byteArray4;
				AdvertiseEventArgs advertiseEventArgs1;
				AdvertiseEventArgs advertiseEventArgs2;
				DeviceBroadcastPacket deviceBroadcastPacket2;
				AdvertiseEventArgs advertiseEventArgs3;
				AdvertiseEventArgs advertiseEventArgs4;
				string[] stringArray1;
				string[] stringArray2;
				i1 = 0;
				while (i1 < BroadcastPacketList.Instance.Count)
				{
					deviceBroadcastPacket1 = BroadcastPacketList.Instance[i1];
					if (((((pipAddress != null) && (deviceBroadcastPacket1.ServerAddress != null)) || (deviceBroadcastPacket1.ServerData.MACAddressString.CompareTo (newDataPackage.MACAddressString) != 0)) && (((pipAddress == null) || (deviceBroadcastPacket1.ServerAddress == null)) || (deviceBroadcastPacket1.ServerData.MACAddressString.CompareTo (newDataPackage.MACAddressString) != 0))) || (deviceBroadcastPacket1.GetDataType () != newDataPackage.GetType ()))
					{
						i1++;
						continue;
					}
					deviceBroadcastPacket1.ServerAddress = pipAddress;
					b1 = false;
					if (newDataPackage is SysInfoData)
					{
						byteArray1 = ((SysInfoData) deviceBroadcastPacket1.ServerData).ToBytes ();
						byteArray2 = ((SysInfoData) newDataPackage).ToBytes ();
						b1 = (! ArrayEx.CompareTo (byteArray1, byteArray2));
						goto L_00DC;
					}
					byteArray3 = ((StatInfoData) deviceBroadcastPacket1.ServerData).ToBytes ();
					byteArray4 = ((StatInfoData) newDataPackage).ToBytes ();
					b1 = (! ArrayEx.CompareTo (byteArray3, byteArray4));
					goto L_00DC;
				}
				deviceBroadcastPacket2 = new DeviceBroadcastPacket (pipAddress, newDataPackage, LECReceiveThread.ExpirationTime);
				deviceBroadcastPacket2.OnAdvertiseEvent += new AdvertiseEventHandler (this.OnAdvertiseEvent);
				int i2 = BroadcastPacketList.Instance.Add (deviceBroadcastPacket2);
				if (newDataPackage is SysInfoData)
				{
					advertiseEventArgs3 = new AdvertiseEventArgs (deviceBroadcastPacket2.GetDataType ().ToString (), ((deviceBroadcastPacket2.ServerAddress == null) ? IPAddress.Parse ("127.0.0.1") : deviceBroadcastPacket2.ServerAddress), LECReceiveThread.AdvertiseAddSysInfo);
					this.OnAdvertiseEvent (this, advertiseEventArgs3);
					goto L_029F;
				}
				advertiseEventArgs4 = new AdvertiseEventArgs (deviceBroadcastPacket2.GetDataType ().ToString (), ((deviceBroadcastPacket2.ServerAddress == null) ? IPAddress.Parse ("127.0.0.1") : deviceBroadcastPacket2.ServerAddress), LECReceiveThread.AdvertiseAddStatInfo);
				this.OnAdvertiseEvent (this, advertiseEventArgs4);
				goto L_029F;
				
			L_00DC:
				
				{
				}
				deviceBroadcastPacket1.ServerData = newDataPackage;
				if (b1)
				{
					if (! (newDataPackage is SysInfoData))
					{
						advertiseEventArgs2 = new AdvertiseEventArgs (deviceBroadcastPacket1.GetDataType ().ToString (), ((deviceBroadcastPacket1.ServerAddress == null) ? IPAddress.Parse ("127.0.0.1") : deviceBroadcastPacket1.ServerAddress), LECReceiveThread.AdvertiseUpdateStatInfo);
						this.OnAdvertiseEvent (this, advertiseEventArgs2);
					}
					else
					{
						advertiseEventArgs1 = new AdvertiseEventArgs (deviceBroadcastPacket1.GetDataType ().ToString (), ((deviceBroadcastPacket1.ServerAddress == null) ? IPAddress.Parse ("127.0.0.1") : deviceBroadcastPacket1.ServerAddress), LECReceiveThread.AdvertiseUpdateSysInfo);
						this.OnAdvertiseEvent (this, advertiseEventArgs1);
					}
				}
				stringArray1 = new string[] { "LECReceive.UpdateServerList() - Server ", ((pipAddress == null) ? "127.0.0.1" : pipAddress.ToString ()), " holding ", newDataPackage.GetType ().ToString (), " updated within receive list." };
				Logging.Instance.Log (4, string.Concat (stringArray1));
				return;
				
			L_029F:
				
				{
				}
				stringArray2 = new string[] { "LECReceive.UpdateServerList() - Server ", ((pipAddress == null) ? "127.0.0.1" : pipAddress.ToString ()), " holding ", newDataPackage.GetType ().ToString (), " added to receive list." };
				Logging.Instance.Log (4, string.Concat (stringArray2));
			}
			
		#endregion
	}
	
}

